/* ***********************************************************
hi_files  Version 0.1.0
サイトマップ作成用　ファイルリスト作成ライブラリ

2014-03-23
hi_tag	http://studyhall.webcrow.jp/
*********************************************************** */
library hi_files;
import 'dart:io';

/**
 *  Get and keep File list
 */
class C_Dir {
  var _oDir;
  int nFilesCount;		// ファイル数
  int nDirsCount;			// ディレクトリ数
  List<String> sTargetExt;	// 対象とする拡張子 (.は含まない)

  List<String> sFileName = new List();
  List<String> sDirectory = new List();
  List<String> sExtension = new List();
  List<DateTime> oTimestamp = new List();

  /**
   * sPath : Set target path
   * sTargetExt : Set target extensions (option)
   */
  C_Dir(String sPath, [this.sTargetExt]) {
    _oDir = new Directory(sPath);
  }

  /**
   * Get file list & parameters.
   *
   * nMode 1:Debug mode (print information)
   * return : files count.
   */
  int getSync([num nMode]) {
  	nFilesCount = 0;
  	nDirsCount = 0;
    FileSystemEntity oFiles;

    List<FileSystemEntity> sFile = _oDir.listSync(recursive: true);

    sFile.forEach((oFiles) {
      if (oFiles is File) {
				if (nMode == 1) print('Sync file ${oFiles.path}');
				// ファイル情報の取得
				String sFullpath = oFiles.path;
		  	String sDir = sFullpath.substring(0, sFullpath.lastIndexOf('\\'));
      	String sFile = sFullpath.substring(sFullpath.lastIndexOf('\\') + 1);
      	String sExt = sFile.substring(sFile.lastIndexOf('.') + 1);
      	// 拡張子フィルター
      	bool bDo = false;
      	if (sTargetExt != null) {
      		if (sTargetExt.indexOf(sExt) != -1) {
      			bDo = true;
      		}
      	} else {
      		// 拡張子の指定がない時は全て対象
      		bDo = true;
      	}
      	if (bDo) {
    	  	sDirectory.add(sDir);
      	  sFileName.add(sFile);
        	sExtension.add(sExt);
  				oTimestamp.add(oFiles.lastModifiedSync());
  				nFilesCount += 1;
    		}
      } else if (oFiles is Directory) {
        nDirsCount += 1;
        if (nMode == 1) print('Sync Dir ${oFiles.path}');
      }
    });
    return nFilesCount;
  }
}
